'''
Christian Pluchar- SURF17

makePlots.py 

Generates plots for photonAbsorptionAnalysis.py

Uses matplotlib

'''


import matplotlib
import numpy as np
matplotlib.use('TkAgg')

import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from scipy.optimize import curve_fit

def makePlots(inputMeanData, inputStDevData):

	meanData, stDevData = inputMeanData, inputStDevData

	#mean vs position
	plot1 = plt.figure(1)
	position = np.arange(len(meanData))
	plt.scatter(position, meanData, marker=u'+', c='r', s=1)
	largest_mean = 0
	largest_mean_position = 0
	smallest_mean = meanData[0]
	smallest_mean_position = 0
	for index in range(0, len(meanData)):
		if int(meanData[index]) > int(largest_mean):
			largest_mean = meanData[index]
			largest_mean_position = index
		if int(meanData[index]) < int(smallest_mean):
			smallest_mean = meanData[index]
			smallest_mean_position = index
	print(largest_mean)
	plt.xlabel('Position')
	plt.ylabel('Mean')
	plt.title('Mean Counts vs Position (Test)')
	yfine = np.linspace(0, largest_mean, num=100)
	largest_mean_position_iterable = np.full_like(yfine, largest_mean_position)
	plt.text(largest_mean_position, 80, largest_mean_position)
	plt.plot(largest_mean_position_iterable, yfine, 'b-')


	#stDev vs Mean
	plot2 = plt.figure(2)
	plt.scatter(meanData, stDevData, marker=u'+', c='r', s=1)
	plt.xlabel('Mean')
	plt.ylabel('Standard Deviation')
	plt.title('Pixel Standard Deviation vs Mean Counts (All data)')
	plt.ylim(0,1250)

	print(smallest_mean)
	print(largest_mean)

	param_bounds=([0, 0, 0], [13, np.inf, np.inf])

	#need to increase maxfev to give it enough tries to get the fit right
	popt, pcov = curve_fit(customFunction, meanData, stDevData)

	xfinePlot = np.linspace(0, largest_mean, num=100)  # define values to plot the function for
	xfineFit = np.linspace(smallest_mean, largest_mean, num=100)
	#plt.plot(xfinePlot, customFunction(xfineFit, *popt), 'b-')


	# #stDev vs Mean
	# plot3 = plt.figure(2)
	# plt.scatter(meanData, stDevData, marker=u'+', c='r', s=1)
	# plt.xlabel('Mean')
	# plt.ylabel('Standard Deviation')
	# plt.title('Pixel Standard Deviation vs Mean Counts')
	# plt.plot(xfine, customFunction(xfine, *popt), 'b-')



	# #3d plot of intensity 
	# plot4 = plt.figure(4)
	# ax = fig.add_subplot(111, projection='3d')

	# x = np.linspace(0, stackedCountMatrices.sizes[1])
	# y = np.linspace(0, stackedCountMatrices.sizes[0])
	# z = stackedCountMatrices[y,x]

	# ax.scatter(x, y, z, c='r', marker='o')

	# ax.set_xlabel('X Label')
	# ax.set_ylabel('Y Label')
	# ax.set_zlabel('Z Label')

	print('popt ', popt)


	# # with open(directory + 'fitParameters.csv', 'w') as f:
	# #     writer = csv.writer(f)
	# #     writer.writerows(popt)
	# #     writer.writerows(pcov)

	plt.show()
	return popt, pcov

#custom function for fitting the data 
#y=sqrt(a0+a1*x+a2*x^2)
#where y is standard deviation, x is the mean, a0 is electronics noise,
#a1 is shot noise coefficent, and a2 is the amplitude noise coefficient

def customFunction(x, a0, a1, a2):
	return np.sqrt(np.abs(a0 + a1 * x + a2 * x**2))




